## bisect-ppx 2.8.3%2Bdfsg

=== Makefile ===
.PHONY : build
build :
	dune build -p bisect_ppx

.PHONY : watch
watch :
	dune build -p bisect_ppx -w

TEST := @runtest

.PHONY : test
test : build
	dune build -p bisect_ppx $(TEST)

.PHONY : promote
promote :
	dune promote

SELF_COVERAGE := _self

.PHONY : clean
clean :
	dune clean
	make clean-usage
	make -C test/js clean
	rm -rf $(SELF_COVERAGE)

INSTALLED_ENVIRONMENT := \
    OCAMLPATH=`pwd`/_build/install/default/lib \
    PATH=`pwd`/_build/install/default/bin:$$PATH

.PHONY : usage
usage : build
	for TEST in `ls -d test/usage/*` ; \
	do \
		echo ; \
		echo ; \
		$(INSTALLED_ENVIRONMENT) make -wC $$TEST || exit 2 ; \
	done

.PHONY : clean-usage
clean-usage :
	for TEST in `ls -d test/usage/*` ; \
	do \
		make -wC $$TEST clean ; \
	done

GH_PAGES := gh-pages

.PHONY : gh-pages
gh-pages:
	cat doc/header.html > $(GH_PAGES)/index.html
	cat README.md | node doc/convert-readme.js >> $(GH_PAGES)/index.html
	cat doc/footer.html >> $(GH_PAGES)/index.html

.PHONY : self-coverage
self-coverage : self-coverage-workspace self-coverage-rename self-coverage-test

SOURCES := bisect_ppx.opam dune-project src/

.PHONY : self-coverage-workspace
self-coverage-workspace :
	rm -rf $(SELF_COVERAGE)/bisect_ppx
	rm -rf $(SELF_COVERAGE)/meta_bisect_ppx
	mkdir -p $(SELF_COVERAGE)
	touch $(SELF_COVERAGE)/dune-workspace
	mkdir -p $(SELF_COVERAGE)/meta_bisect_ppx
	mkdir -p $(SELF_COVERAGE)/bisect_ppx
	cp -r $(SOURCES) $(SELF_COVERAGE)/meta_bisect_ppx/
	cp -r $(SOURCES) $(SELF_COVERAGE)/bisect_ppx/
	mkdir -p $(SELF_COVERAGE)/bisect_ppx/test
	cp -r test $(SELF_COVERAGE)/bisect_ppx/test/
	cd $(SELF_COVERAGE)/meta_bisect_ppx && \
	  patch --no-backup-if-mismatch -p2 < ../../test/self/meta_bisect_ppx.diff
	cd $(SELF_COVERAGE)/bisect_ppx && \
	  patch --no-backup-if-mismatch -p2 < ../../test/self/bisect_ppx.diff

.PHONY : self-coverage-rename
self-coverage-rename :
	mv \
	  $(SELF_COVERAGE)/meta_bisect_ppx/bisect_ppx.opam \
	  $(SELF_COVERAGE)/meta_bisect_ppx/meta_bisect_ppx.opam
	mv \
	  $(SELF_COVERAGE)/meta_bisect_ppx/src/common/bisect_common.ml \
	  $(SELF_COVERAGE)/meta_bisect_ppx/src/common/meta_bisect_common.ml
	mv \
	  $(SELF_COVERAGE)/meta_bisect_ppx/src/common/bisect_common.mli \
	  $(SELF_COVERAGE)/meta_bisect_ppx/src/common/meta_bisect_common.mli

FILTER := 's/^\(\(---\|+++\) [^ \t]*\).*$$/\1/g'

.PHONY : self-coverage-diff
self-coverage-diff :
	find . -name .merlin | xargs rm -f
	diff -ru src _self/meta_bisect_ppx/src | \
	  sed $(FILTER) > \
	  test/self/meta_bisect_ppx.diff || \
	  true
	diff -ru src _self/bisect_ppx/src | \
	  sed $(FILTER) > \
	  test/self/bisect_ppx.diff || \
	  true

EXPECTED_FILES := \
  --expect bisect_ppx/src/ \
  --do-not-expect bisect_ppx/src/ppx/js/ \
  --do-not-expect bisect_ppx/src/runtime/js/

.PHONY : self-coverage-test
self-coverage-test :
	cd $(SELF_COVERAGE) && rm -f bisect*.meta
	cd $(SELF_COVERAGE) && dune build @install --instrument-with meta_bisect_ppx
	cd $(SELF_COVERAGE) && \
	  dune build --force --instrument-with meta_bisect_ppx $(TEST)
	rm -rf _coverage
	cd $(SELF_COVERAGE) && \
	  _build/install/default/bin/meta-bisect-ppx-report \
	    html -o ../_coverage bisect*.meta $(EXPECTED_FILES) --verbose
	cd $(SELF_COVERAGE) && \
	  _build/install/default/bin/meta-bisect-ppx-report \
	    summary bisect*.meta --verbose
	@echo See _coverage/index.html

=== test/usage/dune-conditional/Makefile ===
.PHONY : test
test : clean
	dune exec ./source.exe
	! test -f bisect*.coverage
	dune clean
	BISECT_ENABLE=YES dune exec ./source.exe
	ls -l _build
	test -f bisect*.coverage

.PHONY : clean
clean :
	dune clean
	rm -f bisect*.coverage

=== test/usage/dune-integration/Makefile ===
.PHONY : test
test : clean
	dune exec ./source.exe
	! test -f bisect*.coverage
	dune clean
	dune exec --instrument-with bisect_ppx ./source.exe
	ls -l _build
	test -f bisect*.coverage

.PHONY : clean
clean :
	dune clean
	rm -f bisect*.coverage

=== test/usage/reason/Makefile ===
.PHONY : test
test : clean
	dune exec ./source.exe
	! test -f bisect*.coverage
	dune clean
	BISECT_ENABLE=YES dune exec ./source.exe
	ls -l _build
	test -f bisect*.coverage
	bisect-ppx-report html

.PHONY : clean
clean :
	dune clean
	rm -rf bisect*.coverage _coverage

=== debian/control ===
Source: bisect-ppx
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Bo YU <tsu.yubo@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 libcmdliner-ocaml-dev,
 ocaml-dune,
 ocaml,
 dh-ocaml (>= 1.2),
 libppxlib-ocaml-dev,
 help2man,
 uglifyjs,
Standards-Version: 4.7.0
Homepage: https://github.com/aantron/bisect_ppx
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/bisect-ppx.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/bisect-ppx

Package: libbisect-ppx-ocaml
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: Code coverage for OCaml and ReScript (runtime files)
 Bisect-ppx helps you test thoroughly. It is a small preprocessor
 that inserts instrumentation at places in your code, such as if-then-else and
 match expressions. After you run tests, Bisect_ppx gives a nice HTML report
 showing which places were visited and which were missed.
 .
 This package contains runtime files.

Package: libbisect-ppx-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: Code coverage for OCaml and ReScript (dev files)
 Bisect_ppx helps you test thoroughly. It is a small preprocessor
 that inserts instrumentation at places in your code, such as if-then-else and
 match expressions. After you run tests, Bisect_ppx gives a nice HTML report
 showing which places were visited and which were missed.
 .
 This package contains development files.

## bisect-ppx 2.8.3+dfsg

=== test/js/Makefile ===
.PHONY : test
test :
	rm -rf _coverage *.coverage
	npm run instrument
	npm run execute
	./node_modules/.bin/bisect-ppx-report html
	./node_modules/.bin/bisect-ppx-report summary | diff expected -
	./node_modules/.bin/bisect-ppx-report summary
	@echo "See _coverage/index.html."

.PHONY : full-test
full-test : clean install test

.PHONY : install
install :
	npm pack ../..
	tar xf *.tgz
	npm install
	npm list || true

.PHONY : clean
clean :
	rm -rf node_modules lib _esy *.tgz package *.coverage _coverage \
	  package-lock.json

.PHONY : clean-for-caching
clean-for-caching :
	npm uninstall --no-save bisect_ppx || true
	rm -rf node_modules/bisect_ppx

=== test/usage/dune-linkall/Makefile ===
.PHONY : test
test :
	dune exec ./source.exe
	! test -f bisect*.coverage

.PHONY : clean
clean :
	dune clean
	rm -f bisect*.coverage

=== test/usage/dune-unconditional/Makefile ===
.PHONY : test
test : clean
	dune exec ./source.exe
	test -f bisect*.coverage

.PHONY : clean
clean :
	dune clean
	rm -f bisect*.coverage

=== test/usage/js_of_ocaml/Makefile ===
.PHONY : test
test : clean
	dune build ./source.bc.js
	node _build/default/source.bc.js
	! test -f bisect*.coverage
	dune clean
	BISECT_ENABLE=YES dune build ./source.bc.js
	node _build/default/source.bc.js
	ls -l _build
	test -f bisect*.coverage

.PHONY : clean
clean :
	dune clean
	rm -f bisect*.coverage

=== test/usage/ocamlfind/Makefile ===
BISECT := -package bisect_ppx -ppxopt bisect_ppx,--conditional

.PHONY : test
test : clean
	ocamlfind opt -linkpkg source.ml
	./a.out
	! test -f bisect*.coverage
	@# If the PPX option is passed correctly, there will be no output.
	ocamlfind opt -linkpkg $(BISECT) source.ml
	./a.out
	! test -f bisect*.coverage
	BISECT_ENABLE=YES ocamlfind opt -linkpkg $(BISECT) source.ml
	./a.out
	test -f bisect*.coverage

.PHONY : clean
clean :
	rm -f *.cm* *.o a.out bisect*.coverage

=== debian/changelog ===
bisect-ppx (2.8.3+dfsg-4) unstable; urgency=medium

  * Team upload
  * Update ppxlib 0.36.0 patch

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Sep 2025 11:10:14 +0200

bisect-ppx (2.8.3+dfsg-3) unstable; urgency=medium

  * Team upload
  * Add support for ppxlib 0.36.0
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Wed, 10 Sep 2025 12:33:13 +0200

bisect-ppx (2.8.3+dfsg-2) unstable; urgency=medium

  * Team upload
  * Fix build on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Aug 2024 11:50:47 +0200

bisect-ppx (2.8.3+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1068621)

 -- Bo YU <tsu.yubo@gmail.com>  Fri, 12 Apr 2024 22:31:06 +0800

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
  ocaml-dune,
  ocaml,
  dh-ocaml (>= 1.2),
- libppxlib-ocaml-dev,
+ libppxlib-ocaml-dev (>= 0.36.0),
  help2man,
  uglifyjs,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/aantron/bisect_ppx
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/ocaml-team/bisect-ppx.git

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//, \
   repacksuffix=+dfsg, repack, \
   filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/aantron/bisect_ppx/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
